4 . git-sh-setup || die "Not a git archive"
7 echo >&2 "usage: $0 [--signoff] [--dotest=<dir>] [--utf8] [--3way] <mbox>"
8 echo >&2 " or, when resuming"
9 echo >&2 " $0 [--skip | --resolved]"
14 echo "$1" >"$dotest/next"
19 rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
20 "$dotest/patch" "$dotest/info"
21 echo "$next" >"$dotest/next"
26 O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
28 rm -fr "$dotest"/patch-merge-*
29 mkdir "$dotest/patch-merge-tmp-dir"
31 # First see if the patch records the index info that we can use.
32 if git-apply -z --index-info "$dotest/patch" \
33 >"$dotest/patch-merge-index-info" 2>/dev/null &&
34 GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
35 git-update-index -z --index-info <"$dotest/patch-merge-index-info" &&
36 GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
37 git-write-tree >"$dotest/patch-merge-base+" &&
38 # index has the base tree now.
40 cd "$dotest/patch-merge-tmp-dir" &&
41 GIT_INDEX_FILE="../patch-merge-tmp-index" \
42 GIT_OBJECT_DIRECTORY="$O_OBJECT" \
43 git-apply --index <../patch
46 echo Using index info to reconstruct a base tree...
47 mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
48 mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
50 # Otherwise, try nearby trees that can be used to apply the
55 # Hoping the patch is against our recent commits...
56 git-rev-list --max-count=$N HEAD
58 # or hoping the patch is against known tags...
59 git-ls-remote --tags .
63 # See if we have it as a tree...
64 git-cat-file tree "$base" >/dev/null 2>&1 || continue
66 rm -fr "$dotest"/patch-merge-* &&
67 mkdir "$dotest/patch-merge-tmp-dir" || break
69 cd "$dotest/patch-merge-tmp-dir" &&
70 GIT_INDEX_FILE=../patch-merge-tmp-index &&
71 GIT_OBJECT_DIRECTORY="$O_OBJECT" &&
72 export GIT_INDEX_FILE GIT_OBJECT_DIRECTORY &&
73 git-read-tree "$base" &&
75 mv ../patch-merge-tmp-index ../patch-merge-index &&
76 echo "$base" >../patch-merge-base
77 ) <"$dotest/patch" 2>/dev/null && break
81 test -f "$dotest/patch-merge-index" &&
82 his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git-write-tree) &&
83 orig_tree=$(cat "$dotest/patch-merge-base") &&
84 rm -fr "$dotest"/patch-merge-* || exit 1
86 echo Falling back to patching base and 3-way merge...
88 # This is not so wrong. Depending on which base we picked,
89 # orig_tree may be wildly different from ours, but his_tree
90 # has the same set of wildly different changes in parts the
91 # patch did not touch, so resolve ends up cancelling them,
92 # saying that we reverted all those changes.
94 git-merge-resolve $orig_tree -- HEAD $his_tree || {
95 echo Failed to merge in the changes.
101 dotest=.dotest sign= utf8= keep= skip= interactive= resolved=
103 while case "$#" in 0) break;; esac
106 -d=*|--d=*|--do=*|--dot=*|--dote=*|--dotes=*|--dotest=*)
107 dotest=`expr "$1" : '-[^=]*=\(.*\)'`; shift ;;
108 -d|--d|--do|--dot|--dote|--dotes|--dotest)
109 case "$#" in 1) usage ;; esac; shift
112 -i|--i|--in|--int|--inte|--inter|--intera|--interac|--interact|\
113 --interacti|--interactiv|--interactive)
114 interactive=t; shift ;;
116 -3|--3|--3w|--3wa|--3way)
118 -s|--s|--si|--sig|--sign|--signo|--signof|--signoff)
120 -u|--u|--ut|--utf|--utf8)
122 -k|--k|--ke|--kee|--keep)
125 -r|--r|--re|--res|--reso|--resol|--resolv|--resolve|--resolved)
140 # If the dotest directory exists, but we have finished applying all the
141 # patches in them, clear it out.
142 if test -d "$dotest" &&
143 last=$(cat "$dotest/last") &&
144 next=$(cat "$dotest/next") &&
146 test "$next" -gt "$last"
153 test ",$#," = ",0," ||
154 die "previous dotest directory $dotest still exists but mbox given."
157 # Make sure we are not given --skip nor --resolved
158 test ",$skip,$resolved," = ,,, ||
159 die "we are not resuming."
162 mkdir -p "$dotest" || exit
164 # cat does the right thing for us, including '-' to mean
167 git-mailsplit -d$prec "$dotest/" >"$dotest/last" || {
172 # -s, -u and -k flags are kept for the resuming session after
174 # -3 and -i can and must be given when resuming.
175 echo "$sign" >"$dotest/sign"
176 echo "$utf8" >"$dotest/utf8"
177 echo "$keep" >"$dotest/keep"
178 echo 1 >"$dotest/next"
183 files=$(git-diff-index --cached --name-only HEAD) || exit
184 if [ "$files" ]; then
185 echo "Dirty index: cannot apply patches (dirty: $files)" >&2
190 if test "$(cat "$dotest/utf8")" = t
194 if test "$(cat "$dotest/keep")" = t
198 if test "$(cat "$dotest/sign")" = t
200 SIGNOFF=`git-var GIT_COMMITTER_IDENT | sed -e '
202 s/^/Signed-off-by: /'
208 last=`cat "$dotest/last"`
209 this=`cat "$dotest/next"`
212 this=`expr "$this" + 1`
215 if test "$this" -gt "$last"
222 while test "$this" -le "$last"
224 msgnum=`printf "%0${prec}d" $this`
225 next=`expr "$this" + 1`
226 test -f "$dotest/$msgnum" || {
231 # If we are not resuming, parse and extract the patch information
232 # into separate files:
233 # - info records the authorship and title
234 # - msg is the rest of commit log message
235 # - patch is the patch body.
237 # When we are resuming, these files are either already prepared
238 # by the user, or the user can tell us to do so by --resolved flag.
241 git-mailinfo $keep $utf8 "$dotest/msg" "$dotest/patch" \
242 <"$dotest/$msgnum" >"$dotest/info" ||
244 git-stripspace < "$dotest/msg" > "$dotest/msg-clean"
248 GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
249 GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
250 GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
251 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
253 SUBJECT="$(sed -n '/^Subject/ s/Subject: //p' "$dotest/info")"
254 case "$keep_subject" in -k) SUBJECT="[PATCH] $SUBJECT" ;; esac
258 if test '' != "$SIGNOFF"
261 sed -ne '/^Signed-off-by: /p' \
262 "$dotest/msg-clean" |
266 test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
267 test '' = "$LAST_SIGNED_OFF_BY" && echo
275 if test -s "$dotest/msg-clean"
278 cat "$dotest/msg-clean"
280 if test '' != "$ADD_SIGNOFF"
284 } >"$dotest/final-commit"
287 case "$resolved,$interactive" in
289 # This is used only for interactive view option.
290 git-diff-index -p --cached HEAD >"$dotest/patch"
296 if test "$interactive" = t
299 die "cannot be interactive without stdin connected to a terminal."
301 while test "$action" = again
303 echo "Commit Body is:"
304 echo "--------------------------"
305 cat "$dotest/final-commit"
306 echo "--------------------------"
307 echo -n "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
311 [aA]*) action=yes interactive= ;;
312 [nN]*) action=skip ;;
313 [eE]*) "${VISUAL:-${EDITOR:-vi}}" "$dotest/final-commit"
316 LESS=-S ${PAGER:-less} "$dotest/patch" ;;
324 if test $action = skip
330 if test -x "$GIT_DIR"/hooks/applypatch-msg
332 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
337 echo "Applying '$SUBJECT'"
342 git-apply --index "$dotest/patch"
346 # Resolved means the user did all the hard work, and
347 # we do not have to do any patch application. Just
348 # trust what the user has in the index file and the
355 if test $apply_status = 1 && test "$threeway" = t
359 # Applying the patch to an earlier tree and merging the
360 # result may have produced the same tree as ours.
361 changed="$(git-diff-index --cached --name-only -z HEAD)"
362 if test '' = "$changed"
364 echo No changes -- Patch already applied.
368 # clear apply_status -- we have successfully merged.
372 if test $apply_status != 0
374 echo Patch failed at $msgnum.
378 if test -x "$GIT_DIR"/hooks/pre-applypatch
380 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
383 tree=$(git-write-tree) &&
384 echo Wrote tree $tree &&
385 parent=$(git-rev-parse --verify HEAD) &&
386 commit=$(git-commit-tree $tree -p $parent <"$dotest/final-commit") &&
387 echo Committed: $commit &&
388 git-update-ref HEAD $commit $parent ||
391 if test -x "$GIT_DIR"/hooks/post-applypatch
393 "$GIT_DIR"/hooks/post-applypatch